{
  Simple Typeman demo
  18 Sep 2001
}
unit Mainu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, typinfo, StdCtrls,
  ExtCtrls, TypeMan;

type
  TMyColor = (Red, Green, Blue, Cyan, Yellow);
  TMyColors = set of TMyColor;
  TGender = (Male, Female);
  TBankNo = string[10];

  TPerson = class(TPersistent)
  private
    FSurname   : String;
    FFirstName : String;
    FAge       : Byte;
    FColors    : TMyColors;
    FColor     : TMyColor;
    FMale      : TGender;
    FBankNo    : TBankNo;
    FBirthday  : TDate;
  published
    property Surname : String read FSurname write FSurname;
    property FirstName : String read FFirstName write FFirstName;
    property Age : Byte read FAge write FAge;
    property Color : TMyColor read FColor write FColor;
    property Colors : TMyColors read FColors write FColors;
    property Gender : TGender read FMale write FMale default Male;
    property BankNo : TBankNo read FBankNo write FBankNo;
    property Birthday : TDate read FBirthday write FBirthday;
  end;

  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Memo1: TMemo;
    Panel3: TPanel;
    EPropValue: TEdit;
    EPropName: TEdit;
    bSet: TButton;
    Button6: TButton;
    GroupBox1: TGroupBox;
    Button5: TButton;
    Button4: TButton;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button7: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure bSetClick(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    FPerson : TPerson;
    FPropList : TQPropList;
    procedure DummyValues;
    procedure DummyValues2;
    procedure ToMemo;

    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
procedure TForm1.FormCreate(Sender: TObject);
begin
  FPerson := TPerson.Create;
  FPropList := TQPropList.Create(FPerson);
  DummyValues;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FPropList.Free;
  FPerson.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  FPropList.ClearPropValues;
  ToMemo;
end;

procedure TForm1.DummyValues;
begin
  FPropList.ClearPropValues;
  FPropList['Surname'].AsString := 'Borland';
  FPropList['Surname'].AsString := 'Borland';
  FPropList['FirstName'].AsString := 'Frank';
  FPropList['Age'].AsInteger := 52;
  FPropList['Color'].AsString := 'Green';
  FPropList['Gender'].AsString := 'T';
  FPropList['Colors'].AsString := 'Green,Yellow';
  FPropList['BankNo'].AsString := '872-78929A';
  FPropList['Birthday'].AsDateTime := now-1900;
  ToMemo;
end;

procedure TForm1.DummyValues2;
begin
  FPropList.ClearPropValues;
  FPropList['Surname'].AsString := 'Gates';
  FPropList['FirstName'].AsString := 'Bill';
  FPropList['Age'].AsInteger := 45;
  FPropList['Color'].AsString := 'Red';
  FPropList['Colors'].AsString := 'Red,Blue';
  FPropList['BankNo'].AsString := '652-78929B';
  FPropList['Birthday'].AsDateTime := now-1800;
  ToMemo;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  DummyValues;
end;

procedure TForm1.Button4Click(Sender: TObject);
var aStream : TFileStream;
begin
  aStream := TFileStream.Create('Person.dat', fmCreate or fmOpenWrite);
  try
    FPropList.WriteToStream(aStream);
  finally
    aStream.Free;
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
var aStream : TFileStream;
begin
  FPropList.ClearPropValues;
  aStream := TFileStream.Create('Person.dat', fmOpenRead);
  try
    FPropList.ReadFromStream(aStream);
  finally
    aStream.Free;
  end;
  ToMemo;
end;

procedure TForm1.ToMemo;
begin
  Memo1.Text := '';
  FPropList.ValuesToSL(Memo1.Lines, True);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  DummyValues2;
end;

procedure TForm1.bSetClick(Sender: TObject);
begin
  FPropList[ePropName.Text].AsString := ePropvalue.Text;
  ToMemo;
end;

procedure TForm1.Button6Click(Sender: TObject);
var p : TQPropList;
begin
  Memo1.Text := '';
  p := TQPropList.Create(Self, False, [ptClass]);
  try
    p.TypesToSL(Memo1.Lines);
  finally
    p.Free;
  end;
end;

procedure TForm1.Button7Click(Sender: TObject);
var pl : TQPropList;
begin
 pl := TQPropList.Create(Form1.Button1);
 if pl['width'].AsInteger > 1000 then
 begin
   ShowMessage('You are about to create a big button!');
   pl['width'].AsInteger := 10;
 end;


  TypeUtils.SetProperties(Self, 'ParentColor', False, TypeInfo(Boolean));
  TypeUtils.SetProperties(Self, 'Color', clTeal, TPanel);
end;

end.




